/* readlines.l - a scanner to read (potentially long) lines from a file */

%{
static const  char  rcsid [] = "$Id: readlines.l,v 1.1.1.1 2002/10/13 11:10:08 voss Exp $";

#include <string.h>

#include "rndlib.h"
#include "readlines.h"
%}

%option nounput
%option noyywrap
%%
.*	{
	  if (buffer.used >= buffer.slots) {
	    buffer.slots += 100;
	    buffer.data = xrealloc (buffer.data,
				    buffer.slots*sizeof(struct line));
	  }
	  buffer.data[buffer.used].size = yyleng;
	  if (yyleng) {
	    buffer.data[buffer.used].data = xmalloc (yyleng);
	    memcpy (buffer.data[buffer.used].data, yytext, yyleng);
	  } else {
	    buffer.data[buffer.used].data = NULL;
	  }
	  ++buffer.used;
	}
\n	/* ignore */
