/* rndlib.h - common declarations for the random-utils
 *
 * Copyright (C) 1998, 2001  Jochen Voss.
 *
 * $Id: rndlib.h,v 1.1.1.1 2002/10/13 11:10:08 voss Exp $ */

#ifndef FILE_RNDLIB_H_SEEN
#define FILE_RNDLIB_H_SEEN

#include <stdlib.h>

#ifdef __GNUC__
#define  LIBV_NORETURN_FN  __attribute__ ((noreturn))
#define  LIBV_PRINTF_FN  __attribute__ ((format (printf, 1, 2)))
#else
#define  LIBV_NORETURN_FN
#define  LIBV_PRINTF_FN
#endif

/* error.c */
extern  void  fatal (const char *format, ...) LIBV_NORETURN_FN LIBV_PRINTF_FN;
extern  void  error (const char *format, ...) LIBV_PRINTF_FN;
extern  void  warning (const char *format, ...) LIBV_PRINTF_FN;

/* xmalloc.c */
extern  void *xmalloc (size_t size);
extern  void *xrealloc (void *ptr, size_t size);

/* xstrdup.c */
extern  char *xstrdup (const char *str);
extern  char *xstrndup (const char *str, size_t size);

/* from "vgetopt.c" */
struct voption {
  const char  *name;		/* long option name */
  char  short_name;		/* short option name */
  int *flag_ptr;		/* where is the flag */
  int  has_arg;			/* Is there an argument? */
  const char *arg_name;		/* name of the argument */
  const char *help;		/* "--help" line */
};

#define V_MIXED		1
#define V_ONE_HYPHEN	2
#define V_KEEP_UNKNOWN	4
#define V_NO_JOIN	8

extern  int  vgetopt (const struct voption *, const char **, int);
extern  void  vendopt (void);
extern  void  show_options (const struct voption *);

/* from "vinit.c" */
extern  char **orig_argv;
extern  int  orig_argc;
extern  char **xargv;
extern  int  xargc, xargv_len;

extern  char *myname;
extern  int  interactive_flag;

extern  void  vinit (int argc, char **argv);
extern  void  vexit (void);

#endif /* FILE_RNDLIB_H_SEEN */
